/* compact formatting code based on rprintf by martin thomas
 * Changes made by outer_space:
 * -Renamed functions with prnt instead of print to note abbreviated 
nature
 * -Changed from putchar function to dma putstring function
 * -DMA serial specific to sam7s
 * -Reduced size and functionality
 * -Added %f
 * -All output via prntf, change only the header for different platforms
 */

#include "prntf.h"
#include <stdarg.h>

void sprntf(char* dest,char const *format, ...)
{
	char format_flag;
	char *ptr;
	char hold [32];
	double fval;
	long int digit, ival;
	va_list ap;
	va_start(ap, format);

	for (;;){
		while ((format_flag = *(format++)) != '%')
		{
			if (!format_flag)
			{
				va_end(ap);
				*dest = 0; //
				return;
			}
			*dest++ = format_flag;
		}
		format_flag = *format++;
		switch (format_flag)
		{
			case 'c':
				format_flag = va_arg(ap,int);
				*dest = format_flag;
				dest++;
				break;

			case 'i': {
				ival = va_arg(ap,int);
				if(ival<0)
				{
					ival = -ival;
					*dest++ = '-';
				}
				ptr = hold;
				for(digit = 100000000; digit >0; digit/=10)
				{
					*ptr++ = ival / digit + '0';
					ival %= digit;
				}
				*ptr = 0; //mark end of string
				ptr = hold; //set pointer back to beginning
				while(*ptr == '0'){ptr++;}
				if(!*ptr){*--ptr = '0';} //if number is zero, must have 1 leading '0'
				while( (*dest++ = *ptr++) ); //strcopy into dest
				dest--; //negate \0
				break;	//*/
			}
			case 's':
				ptr = va_arg(ap,char *);
				while( (*dest++ = *ptr++) ); //strcopy
				dest--; //negate \0
				break;
///*
			case 'f':
				ptr=hold;
				fval = va_arg(ap,double);

				ival = fval*100000;
				for(digit = 1000000000; digit > 0; digit /= 10)
				{
					if(digit == 10000){*ptr++ = '.';} //decimal point here
					*ptr++ = ival / digit + '0';
					ival %= digit;
				}
				while(*--ptr == '0'); //erase trailing zeros
				if(*ptr == '.'){ptr--;} //erase decimal if nothing is after it
				*++ptr = 0; //mark end of string
				ptr = hold; //set pointer back to beginning
				while(*ptr == '0'){ptr++;} //strip leading zeros
				if(*ptr == '.'){*--ptr = '0';} //if nothing to left of '.' must put '0'
				while( (*dest++ = *ptr++) ); //strcopy into dest
				dest--; //negate \0, added before return
				break;
			default:
				*dest++ = '%';
				*dest++ = format_flag;
				break;
		}
	}
}

